; MULTI ROM MENU (sjasm)
; For 16 and 32K roms
; By Maggoo and ericb59 - 2014
; 


	defpage	0,0x4000, 0x4000		; page 0 contains main code + far call routines
	defpage 1,0x4000, 0x4000
	defpage 2,0x4000, 0x4000
	defpage 3,0x4000, 0x4000
	defpage 4,0x4000, 0x4000
	defpage 5,0x4000, 0x4000
	defpage 6,0x4000, 0x8000
	defpage 8,0x4000, 0x4000
	defpage 9,0x4000, 0x4000
	defpage 10,0x4000, 0x4000
	defpage 11,0x4000, 0x4000
	defpage 12,0x4000, 0x4000
	defpage 13,0x4000, 0x8000
	defpage 15,0x4000, 0x4000
	defpage 16,0x4000, 0x4000
	defpage 17,0x4000, 0x8000
	defpage 19,0x4000, 0x4000
	defpage 20,0x4000, 0x8000
	defpage 22,0x4000, 0x4000
	defpage 23,0x4000, 0x8000
	defpage 25,0x4000, 0x4000
	defpage 26,0x4000, 0x4000
	defpage 27,0x4000, 0x8000
	defpage 29,0x4000, 0x4000
	defpage 30,0x4000, 0x4000
	defpage 31,0x4000, 0x4000
	defpage 32,0x4000, 0x8000
	defpage 34,0x4000, 0x4000
	defpage 35,0x4000, 0x4000
	defpage 36,0x4000, 0x4000
	defpage 37,0x4000, 0x4000


        page 0
        code page 0

       	org $4000


	DB "AB"      ; expansion ROM header
	DW start     ; start of the init code, 0 if no initcode
	DW 0         ; pointer to CALL statement handler, 0 if no such handler
	DW 0         ; pointer to expansion device handler, 0 if no such handler
	DW 0         ; pointer to the start of a tokenized basicprogram, 0 if no basicprogram
	DS 6,0       ; room reserved for future extensions


include "vsbios.asm"
tgploadadr:
tcloadadr:
GFX:
        incbin "menu.sc2"

lists:
     db 3             ; how many lists
     dw gamelist,gamelist2,gamelist3

start:
      ei
      ld sp, ($FC4A)              ; set the stack at HIMEM
      call codeinit

      ld a,(#f3e0)
      or 2         ; Set 16x16 sprites
      ld (#f3e0),a

      di
      ld a,2
      call chgmod
      ld a,0
      ld (#f3e6),a
      out (#99),a
      ld a,128+7
      out (#99),a

      ld a,159
      out (#99),a
      ld a,128+3
      out (#99),a

      xor a
      out (#99),a
      ld a,128+4
      out (#99),a

      ld a,0
      ld (clicksw),a                              ; disable keyboard click
      ld (muscnt),a
      ld (currentpage),a
      ld (currentsel),a

      call set_tc
      call set_tgp

      call setbgr
      call setbox
      call init_scroll
      call printlist
      call print_cursor
      ld hl,FX
      call ayFX_SETUP                           ; Initialize Sound Effects
      ld	hl,MUSIC1-100			; hl <- initial address of module - 100
      call	PT3_INIT			; Inits PT3 player
      di
      ld hl,#fd9f
      ld de,saveinterupt
      ld bc,3
      ldir                                      ; save old interrupt
      ld hl,setinterupt
      ld de,#fd9f
      ld bc,3
      ldir
main_loop:
       ei
       jp main_loop
setinterupt:
       jp oninterupt
oninterupt:
      di
      in a,(#99)
      ld a,(timer)
      inc a
      ld (timer),a
      call initputsprite
      ld h,Box_X*8
      ld l,Box_Y*8
      ld ix,corners
      call putsprite
      call do_scroll
      call gest_keyb
      call testspace
      or a
      jp z,startgame
      call PlayMus
      ret

gest_keyb:
        call Read_Joystick_Keyboard
        ld (joy_value),a	; save value
        cp 0
        jp z,resetpingpong
        cp 3
        jp z,next_page
        cp 7
        jp z,previous_page
        cp 5
        jp z,next_game
        cp 1
        jp z,previous_game
        ret
resetpingpong:
        xor a
        ld (pingpong),a
        ret
next_game:
          ld a,(pingpong)
          cp 0
          ret nz
          ld a,(currentsel)
          inc a
          ld hl,nbgames
          cp (hl)
          ret nc
          call delete_cursor
          ld a,(currentsel)
          inc a
          ld hl,nbgames
          cp (hl)
          ret nc
          ld (currentsel),a
          call print_cursor
          ld a,1
          ld (pingpong),a
          ld a,SFX_Move
          ld c,6
          call ayFX_INIT

          ret
previous_game:
          ld a,(pingpong)
          cp 0
          ret nz
          ld a,(currentsel)
          dec a
          cp 255
          ret z
          call delete_cursor
          ld a,(currentsel)
          dec a
          cp 255
          ret z
          ld (currentsel),a
          call print_cursor
          ld a,1
          ld (pingpong),a
           ld a,SFX_Move
           ld c,6
           call ayFX_INIT

          ret

delete_cursor:
      ld h,Cursor_X
      ld a,(currentsel)
      add a,Cursor_Y
      ld l,a
      ld bc,emptyselstr
      call printathl
      ret
print_cursor:
      ld bc,currentselstr
      ld h,Cursor_X
      ld a,(currentsel)
      add a,Cursor_Y
      ld l,a
      call printathl
      ret

previous_page:
          ld a,(pingpong)
          cp 0
          ret nz
          ld a,(currentpage)
          dec a
          cp -1
          ret z
          call delete_cursor
          ld a,(currentpage)
          dec a
          ld (currentpage),a
          call setbox
          call printlist
          xor a
          ld (currentsel),a
          call print_cursor
          ld a,1
          ld (pingpong),a
          ld a,SFX_Move
          ld c,6
          call ayFX_INIT
          ret
next_page:
          ld a,(pingpong)
          cp 0
          ret nz
          ld a,(currentpage)
          inc a
          ld hl,lists
          cp (hl)
          ret nc
          call delete_cursor
          ld a,(currentpage)
          inc a
          ld (currentpage),a
          call setbox
          call printlist
          xor a
          ld (currentsel),a
          call print_cursor

          ld a,1
          ld (pingpong),a
           ld a,SFX_Move
           ld c,6
           call ayFX_INIT
           ret

startgame:
          call disscr
          ld hl,switchbankandrun
          ld de,launch_program
          ld bc,switchend-switchbankandrun
          ldir
          jp launch_program

switchbankandrun:
         di
         ld hl,saveinterupt
         ld de,#fd9f
         ld bc,3
         ldir                                      ; Restore old interrupt

         ld a,(currentpage)
         add a,a
         ld e,a
         ld d,0
         ld hl,lists+1
         add hl,de
         ld e,(hl)
         inc hl
         ld d,(hl)
         push de
         pop hl

         inc hl
         inc hl
         inc hl   ;skip first 3 bytes of list header

        ld a,(currentsel)                 ; Current Selection
        add a,a
        add a,a                           ;* x4
        ld e,a
        ld d,0
        ;ld hl,gamelist                    ; Find starting address
        add hl,de
        push hl
        pop ix
        ld a,(ix+1)                       ; Get Bank
        ld (_bank1),a
        inc a
        ld (_bank2),a
        ld hl,(#4000+2)
        jp (hl)
switchend:

;printframe:
;           ld b,10
;           ld de,#0200
printlist:
          di
          ld a,(currentpage)
          add a,a
          ld e,a
          ld d,0
          ld hl,lists+1
          add hl,de
          ld e,(hl)
          inc hl
          ld d,(hl)
          push de
          pop ix
          ld c,(ix)
          ld b,(ix+1)

          ld l,Title_Y
          ld h,Title_X
          call printathl
          inc ix
          inc ix       ; skip first 2 bytes = title
          ld a,(ix)
          inc ix
          ld (nbgames),a
          ld b,a
          ld h,List_X
          ld l,List_Y
printlistloop:
          push hl
          push bc
          ld c,(ix+2)
          ld b,(ix+3)
          call printathl
          inc ix
          inc ix
          inc ix
          inc ix
          pop bc
          pop hl
          inc hl
          djnz printlistloop
          ld bc,pagestr
          ld h,Page_X
          ld l,Page_Y
          call printathl
          ld a,(currentpage)
          add a,129+"0"
          call outAtoVram
          ld a,"/"+128
          call outAtoVram
          ld a,(lists)
          add a,128+"0"
          call outAtoVram
          ld a,(currentpage)
          cp 0
          call nz,printprevpage
          ld bc,nextstr
          ld hl,lists
          ld a,(currentpage)
          inc a
          cp (hl)
          ret z
          jp printnextpage

printprevpage:
          ld bc,prevstr
          ld hl,#0513
          jp printathl
printnextpage:
          ld bc,nextstr
          ld hl,#1913
          jp printathl

pagestr: db "P"+128,"A"+128,"G"+128,"E"+128," ","!"
prevstr: db "<","<"+1,"!"
nextstr: db "<"+1,">!"
currentselstr: db ">!"
emptyselstr: db 32,"!"

titlelist1:
         DB "KONAMI 1!"
gamelist:
         dw titlelist1              ; Pointer to the list title
         db 10                       ; Number of games in the current list
         db #40,:game0
         dw game0str
         db #40,:game1
         dw game1str
         db #40,:game2
         dw game2str
         db #40,:game3
         dw game3str
         db #40,:game4
         dw game4str
         db #40,:game5
         dw game5str
         db #40,:game6
         dw game6str
         db #40,:game7
         dw game7str
         db #40,:game8
         dw game8str
         db #40,:game9
         dw game9str

game0str:  db "ANTARTIC ADVENTURE!"
game1str:  db "ATHLETIC LAND!"
game2str:  db "CABBAGE PATCH KID!"
game3str:  db "CIRCUS CHARLIE!"
game4str:  db "COMIC BAKERY!"
game5str:  db "FROGGER!"
game6str:  db "GOONIES!"
game7str:  db "HYPER OLYMPIC 1!"
game8str:  db "HYPER OLYMPIC 2!"
game9str:  db "HYPER RALLY!"

titlelist2:
         DB "KONAMI 2!"
gamelist2:
         dw titlelist2            ; Pointer to the list title
         db 10
         db #40,:game10
         dw game10str
         db #40,:game11
         dw game11str
         db #40,:game12
         dw game12str
         db #40,:game13
         dw game13str
         db #40,:game14
         dw game14str
         db #40,:game15
         dw game15str
         db #40,:game16
         dw game16str
         db #40,:game17
         dw game17str
         db #40,:game18
         dw game18str
         db #40,:game19
         dw game19str

game10str:  db "HYPER SPORT 1!"
game11str:  db "HYPER SPORT 2!"
game12str:  db "HYPER SPORT 3!"
game13str:  db "KONAMI BASEBALL!"
game14str:  db "KONAMI BOXING!"
game15str:  db "KONAMI GOLF!"
game16str:  db "KONAMI MAHJONG!"
game17str:  db "KONAMI PING PONG!"
game18str:  db "KONAMI SOCCER!"
game19str:  db "KONAMI TENNIS!"

titlelist3:
           db "KONAMI 3!"
gamelist3:
         dw titlelist3                      ; Pointer to the list title
         db 10                               ; Number of games in the current list
         db #40,:game20
         dw game20str
         db #40,:game21
         dw game21str
         db #40,:game22
         dw game22str
         db #40,:game23
         dw game23str
         db #40,:game24
         dw game24str
         db #40,:game25
         dw game25str
         db #40,:game26
         dw game26str
         db #40,:game27
         dw game27str
         db #40,:game28
         dw game28str
         db #40,:game29
         dw game29str

game20str:  db "KINGS VALLEY!"
game21str:  db "KNIGHTMARE!"
game22str:  db "MONKEY ACADEMY!"
game23str:  db "MOPIRANGER!"
game24str:  db "PIPPOLS!"
game25str:  db "QBERT!"
game26str:  db "ROAD FIGHTER!"
game27str:  db "SUPER COBRA!"
game28str:  db "SKY JAGUAR!"
game29str:  db "TIME PILOT!"

MINC1           incbin "oldskool.pt3";"blank.pt3"
MUSIC1:		equ MINC1+100

FX:
                incbin "fullsfx.afb"
REPLAYER:
       INCLUDE	"PT3-ROM.ASM"
       INCLUDE	"AYFX-ROM.ASM"


        page 1
game1:  incbin "games\athletic.rom"
        page 2
game2:  incbin "games\cabbage.rom"
        page 3
game3:  incbin "games\circus.rom"
        page 4
game4:  incbin "games\cbakery.rom"
        page 5
game5:  incbin "games\FROGGER.rom"
        page 6
game6:  incbin "games\goonies.rom"
        page 8
game7:  incbin "games\HYPEROL1.rom"
        page 9
game8:  incbin "games\HYPEROL2.rom"
        page 10
game9:  incbin "games\HYPERRAL.rom"
        page 11
game10:  incbin "games\HYPERSP1.rom"
        page 12
game11:  incbin "games\HYPERSP2.rom"
        page 13
game12:  incbin "games\HYPERSP3.rom"
        page 15
game0:  incbin "games\KEKKYOKU.rom"
        page 16
game13:  incbin "games\KO-BASE.rom"
        page 17
game14:  incbin "games\KO-BOX.rom"
        page 19
game15:  incbin "games\KO-GOLF.rom"
        page 20
game16:  incbin "games\KO-MAJ.rom"
        page 22
game17:  incbin "games\KO-PING.rom"
        page 23
game18:  incbin "games\KO-SOCC.rom"
        page 25
game19:  incbin "games\KO-TENN.rom"
        page 26
game20:  incbin "games\KVALLEY.rom"
        page 27
game21:  incbin "games\MAJYODEN.rom"
        page 29
game22:  incbin "games\MONKEYAC.rom"
         page 30
game23:  incbin "games\MOPIRANG.rom"
         page 31
game24:  incbin "games\PIPPOLS.rom"
         page 32
game25:  incbin "games\QBERT.rom"
         page 34
game26:  incbin "games\ROADFIGH.rom"
         page 35
game27:  incbin "games\SCOBRA.rom"
         page 36
game28:  incbin "games\SKYJAGUA.rom"
         page 37
game29:  incbin "games\TIMEPILO.rom"

         code page 0 

       org #e000

       INCLUDE	"PT3-RAM.ASM"
       INCLUDE	"AYFX-RAM.ASM"

endpt3ram:
          db 0