; MULTI ROM MENU (sjasm)
; For 16 and 32K roms
; By Maggoo and ericb59 - 2014
; 

	defpage	0,0x4000, 0x4000		; page 0 contains main code + far call routines

	defpage 1,0x4000, 0x4000
	defpage 2,0x4000, 0x4000
	defpage 3,0x4000, 0x4000
	defpage 4,0x4000, 0x4000
	defpage 5,0x4000, 0x4000
	defpage 6,0x4000, 0x4000
	defpage 7,0x4000, 0x4000
	defpage 8,0x4000, 0x8000
	defpage 9,0x4000, 0x4000
	defpage 10,0x4000, 0x4000
	defpage 11,0x4000, 0x4000
	defpage 12,0x4000, 0x4000
	defpage 13,0x4000, 0x4000
	defpage 14,0x4000, 0x4000
	defpage 15,0x4000, 0x4000
	defpage 16,0x4000, 0x4000
	defpage 17,0x4000, 0x4000
	defpage 18,0x4000, 0x4000
	defpage 19,0x4000, 0x4000
	defpage 20,0x4000, 0x4000
	defpage 21,0x4000, 0x4000
	defpage 22,0x4000, 0x4000
	defpage 23,0x4000, 0x4000
	defpage 24,0x4000, 0x4000
	defpage 25,0x4000, 0x4000
	defpage 26,0x4000, 0x4000
	defpage 27,0x4000, 0x4000
	defpage 28,0x4000, 0x8000
	defpage 29,0x4000, 0x8000
	defpage 30,0x4000, 0x8000
	defpage 31,0x4000, 0x8000
	defpage 32,0x4000, 0x8000
	defpage 33,0x4000, 0x8000
	defpage 34,0x4000, 0x8000
	defpage 35,0x4000, 0x8000
	defpage 36,0x4000, 0x8000
	defpage 37,0x4000, 0x2000
	defpage 38,0x4000, 0x2000
	defpage 39,0x4000, 0x8000
	defpage 40,0x4000, 0x4000



        page 0
        code page 0

       	org $4000


	DB "AB"      ; expansion ROM header
	DW start     ; start of the init code, 0 if no initcode
	DW 0         ; pointer to CALL statement handler, 0 if no such handler
	DW 0         ; pointer to expansion device handler, 0 if no such handler
	DW 0         ; pointer to the start of a tokenized basicprogram, 0 if no basicprogram
	DS 6,0       ; room reserved for future extensions


include "vsbios.asm"
tgploadadr:
tcloadadr:
GFX:
        incbin "menu.sc2"

lists:
     db 5             ; how many lists
     dw gamelist,gamelist2,gamelist3,gamelist4,gamelist5

start:
      ei
      ld sp, ($FC4A)              ; set the stack at HIMEM
      call codeinit

      ld a,(#f3e0)
      or 2         ; Set 16x16 sprites
      ld (#f3e0),a

      di
      ld a,2
      call chgmod
      ld a,0
      ld (#f3e6),a
      out (#99),a
      ld a,128+7
      out (#99),a

      ld a,159
      out (#99),a
      ld a,128+3
      out (#99),a

      xor a
      out (#99),a
      ld a,128+4
      out (#99),a

      ld a,0
      ld (clicksw),a                              ; disable keyboard click
      ld (muscnt),a
      ld (currentpage),a
      ld (currentsel),a

      call set_tc
      call set_tgp

      call setbgr
      call setbox
      call init_scroll
      call printlist
      call print_cursor
      ld hl,FX
      call ayFX_SETUP                           ; Initialize Sound Effects
      ld	hl,MUSIC1-100			; hl <- initial address of module - 100
      call	PT3_INIT			; Inits PT3 player
      xor a
      ld (instatus),a
      di
      ld hl,#fd9f
      ld de,saveinterupt
      ld bc,3
      ldir                                      ; save old interrupt
      ld hl,setinterupt
      ld de,#fd9f
      ld bc,3
      ldir
      ei
main_loop:
       jp main_loop
setinterupt:
       jp oninterupt

ackinterupt:
        di
        ld a,(instatus)
        or a
        ret nz
        inc a
        ld (instatus),a
        push af
        push bc
        push hl
        push ix
        push iy
        call oninterupt
        pop iy
        pop ix
        pop hl
        pop bc
        xor a
        ld (instatus),a
        pop af
        ei
        ret
oninterupt:
      di
      ld a,(timer)
      inc a
      ld (timer),a
      call do_scroll
      call PlayMus
      call initputsprite
      ld h,Box_X*8
      ld l,Box_Y*8
      ld ix,corners
      call putsprite
      call gest_keyb
      call testspace
      or a
      jp z,startgame
      call testesc
      cp 0
      jp z,PT3_FORCEMUTE
      ret

PT3_FORCEMUTE:
                    ld	hl,MUSICMUTE-100			; hl <- initial address of module - 100
                    call	PT3_INIT			; Inits PT3 player
                    ret
gest_keyb:
        call Read_Joystick_Keyboard
        ld (joy_value),a	; save value
        cp 0
        jp z,resetpingpong
        cp 3
        jp z,next_page
        cp 7
        jp z,previous_page
        cp 5
        jp z,next_game
        cp 1
        jp z,previous_game
        ret
resetpingpong:
        xor a
        ld (pingpong),a
        ret
next_game:
          ld a,(pingpong)
          cp 0
          ret nz
          ld a,(currentsel)
          inc a
          ld hl,nbgames
          cp (hl)
          ret nc
          call delete_cursor
          ld a,(currentsel)
          inc a
          ld hl,nbgames
          cp (hl)
          ret nc
          ld (currentsel),a
          call print_cursor
          ld a,1
          ld (pingpong),a
          ld a,SFX_Move
          ld c,6
          call ayFX_INIT

          ret
previous_game:
          ld a,(pingpong)
          cp 0
          ret nz
          ld a,(currentsel)
          dec a
          cp 255
          ret z
          call delete_cursor
          ld a,(currentsel)
          dec a
          cp 255
          ret z
          ld (currentsel),a
          call print_cursor
          ld a,1
          ld (pingpong),a
           ld a,SFX_Move
           ld c,6
           call ayFX_INIT

          ret

delete_cursor:
      ld h,Cursor_X
      ld a,(currentsel)
      add a,Cursor_Y
      ld l,a
      ld bc,emptyselstr
      call printathl
      ret
print_cursor:
      ld bc,currentselstr
      ld h,Cursor_X
      ld a,(currentsel)
      add a,Cursor_Y
      ld l,a
      call printathl
      ret

previous_page:
          ld a,(pingpong)
          cp 0
          ret nz
          ld a,(currentpage)
          dec a
          cp -1
          ret z
          call delete_cursor
          ld a,(currentpage)
          dec a
          ld (currentpage),a
          call setbox
          call printlist
          xor a
          ld (currentsel),a
          call print_cursor
          ld a,1
          ld (pingpong),a
          ld a,SFX_Move
          ld c,6
          call ayFX_INIT
          ret
next_page:
          ld a,(pingpong)
          cp 0
          ret nz
          ld a,(currentpage)
          inc a
          ld hl,lists
          cp (hl)
          ret nc
          call delete_cursor
          ld a,(currentpage)
          inc a
          ld (currentpage),a
          call setbox
          call printlist
          xor a
          ld (currentsel),a
          call print_cursor

          ld a,1
          ld (pingpong),a
           ld a,SFX_Move
           ld c,6
           call ayFX_INIT
           ret

startgame:
          call disscr
          ld hl,switchbankandrun
          ld de,launch_program
          ld bc,switchend-switchbankandrun
          ldir
          jp launch_program

switchbankandrun:
         di
         ld hl,saveinterupt
         ld de,#fd9f
         ld bc,3
         ldir                                      ; Restore old interrupt

         ld b,b
         jr $+2

         ld a,(currentpage)
         add a,a
         ld e,a
         ld d,0
         ld hl,lists+1
         add hl,de
         ld e,(hl)
         inc hl
         ld d,(hl)
         push de
         pop hl

         inc hl
         inc hl
         inc hl   ;skip first 3 bytes of list header

        ld a,(currentsel)                 ; Current Selection
        add a,a
        add a,a                           ;* x4
        ld e,a
        ld d,0
        ;ld hl,gamelist                    ; Find starting address
        add hl,de
        push hl
        pop ix
        ld a,(ix+1)                       ; Get Bank
        ld (_bank1),a
        inc a
        ld (_bank2),a
        ld hl,(#4000+2)
        jp (hl)
switchend:

;printframe:
;           ld b,10
;           ld de,#0200
printlist:
          di
          ld a,(currentpage)
          add a,a
          ld e,a
          ld d,0
          ld hl,lists+1
          add hl,de
          ld e,(hl)
          inc hl
          ld d,(hl)
          push de
          pop ix
          ld c,(ix)
          ld b,(ix+1)

          ld l,Title_Y
          ld h,Title_X
          call printathl
          inc ix
          inc ix       ; skip first 2 bytes = title
          ld a,(ix)
          inc ix
          ld (nbgames),a
          ld b,a
          ld h,List_X
          ld l,List_Y
printlistloop:
          push hl
          push bc
          ld c,(ix+2)
          ld b,(ix+3)
          call printathl
          inc ix
          inc ix
          inc ix
          inc ix
          pop bc
          pop hl
          inc hl
          djnz printlistloop
          ld bc,pagestr
          ld h,Page_X
          ld l,Page_Y
          call printathl
          ld a,(currentpage)
          add a,129+"0"
          call outAtoVram
          ld a,"/"+128
          call outAtoVram
          ld a,(lists)
          add a,128+"0"
          call outAtoVram
          ld a,(currentpage)
          cp 0
          call nz,printprevpage
          ld bc,nextstr
          ld hl,lists
          ld a,(currentpage)
          inc a
          cp (hl)
          ret z
          jp printnextpage

printprevpage:
          ld bc,prevstr
          ld hl,#0513
          jp printathl
printnextpage:
          ld bc,nextstr
          ld hl,#1913
          jp printathl

pagestr: db "P"+128,"A"+128,"G"+128,"E"+128," ","!"
prevstr: db "<","<"+1,"!"
nextstr: db "<"+1,">!"
currentselstr: db ">!"
emptyselstr: db 32,"!"

titlelist1:
         DB "KONAMI 1!"
gamelist:
         dw titlelist1              ; Pointer to the list title
         db 10                       ; Number of games in the current list
         db #40,:game0
         dw game0str
         db #40,:game1
         dw game1str
         db #40,:game2
         dw game2str
         db #40,:game3
         dw game3str
         db #40,:game4
         dw game4str
         db #40,:game5
         dw game5str
         db #40,:game6
         dw game6str
         db #40,:game7
         dw game7str
         db #40,:game8
         dw game8str
         db #40,:game9
         dw game9str

game0str:  db "RC700-ATHLETIC LAND!"
game1str:  db "RC701-ANTARTIC ADVENTURE!"
game2str:  db "RC702-MONKEY ACADEMY!"
game3str:  db "RC703-TIME PILOT!"
game4str:  db "RC704-FROGGER!"
game5str:  db "RC705-SUPER COBRA!"
game6str:  db "RC706-VIDEO HUSTLER!"
game7str:  db "RC707-MAHJONG!"
game8str:  db "RC710-TRACK & FIELD 1!"
game9str:  db "RC711-TRACK & FIELD 2!"

titlelist2:
         DB "KONAMI 2!"
gamelist2:
         dw titlelist2            ; Pointer to the list title
         db 10
         db #40,:game10
         dw game10str
         db #40,:game11
         dw game11str
         db #40,:game12
         dw game12str
         db #40,:game13
         dw game13str
         db #40,:game14
         dw game14str
         db #40,:game15
         dw game15str
         db #40,:game16
         dw game16str
         db #40,:game17
         dw game17str
         db #40,:game18
         dw game18str
         db #40,:game19
         dw game19str

game10str:  db "RC712-CIRCUS CHARLIE!"
game11str:  db "RC713-MAGICAL TREE!"
game12str:  db "RC714-COMIC BAKERY!"
game13str:  db "RC715-HYPER SPORTS 1!"
game14str:  db "RC716-CABBAGE PATCH KID!"
game15str:  db "RC717-HYPER SPORTS 2!"
game16str:  db "RC718-HYPER RALLY!"
game17str:  db "RC720-TENNIS!"
game18str:  db "RC721-SKY JAGUAR!"
game19str:  db "RC723-GOLF!"

titlelist3:
           db "KONAMI 3!"
gamelist3:
         dw titlelist3                      ; Pointer to the list title
         db 10                               ; Number of games in the current list
         db #40,:game20
         dw game20str
         db #40,:game21
         dw game21str
         db #40,:game22
         dw game22str
         db #40,:game23
         dw game23str
         db #40,:game24
         dw game24str
         db #40,:game25
         dw game25str
         db #40,:game26
         dw game26str
         db #40,:game27
         dw game27str
         db #40,:game28
         dw game28str
         db #40,:game29
         dw game29str

game20str:  db "RC724-BASEBALL!"
game21str:  db "RC725-YIE AR KUNG FU!"
game22str:  db "RC727-KING'S VALLEY!"
game23str:  db "RC728-MOPIRANGER!"
game24str:  db "RC729-PIPPOLS!"
game25str:  db "RC730-ROAD FIGHTER!"
game26str:  db "RC731-PING PONG!"
game27str:  db "RC732-SOCCER!"
game28str:  db "MAPPY 2!"
game29str:  db "RC734-THE GOONIES!"



titlelist4:
           db "KONAMI 4!"
gamelist4:
         dw titlelist4                      ; Pointer to the list title
         db 10                               ; Number of games in the current list
         db #40,:game30
         dw game30str
         db #40,:game31
         dw game31str
         db #40,:game31
         dw game32str
         db #40,:game33
         dw game33str
         db #40,:game34
         dw game34str
         db #40,:game35
         dw game35str
         db #40,:game36
         dw game36str
         db #40,:game37
         dw game37str
         db #40,:game38
         dw game38str
         db #40,:game39
         dw game39str

game30str:  db "RC736-BOXING!"
game31str:  db "RC737-YIE AR KUNG FU 2!"
game32str:  db "RC739-KNIGHTMARE!"
game33str:  db "RC740-TWIN BEE!"
game34str:  db "RC746-QBERT!"
game35str:  db "KN327-GREEN BERET!"
game36str:  db "G001C-SPARKIE!"
game37str:  db "G002C-JUNO FIRST!"
game38str:  db "G006C-CRAZY TRAIN!"
game39str:  db "BCM5-POOYAN!"


titlelist5:
           db "ACTIVISION!"
gamelist5:
         dw titlelist5                      ; Pointer to the list title
         db 2                               ; Number of games in the current list
         db #40,:game40
         dw game40str
         db #40,:game41
         dw game41str

game40str:  db "BEAM RIDER!"
game41str:  db "GHOST BUSTER!"



MINC1           incbin "Karboflex.pt3";"blank.pt3"
MUSIC1:		equ MINC1+100

MINCMUTE           incbin "blank.pt3"
MUSICMUTE:	   equ MINCMUTE+100

FX:
                incbin "fullsfx.afb"
REPLAYER:
       INCLUDE	"PT3-ROM.ASM"
       INCLUDE	"AYFX-ROM.ASM"


        page 1
game0:  incbin "games\rc700.rom"
        page 2
game1:  incbin "games\rc701.rom"
        page 3
game2:  incbin "games\rc702.rom"
        page 4
game3:  incbin "games\rc703.rom"
        page 5
game4:  incbin "games\rc704.rom"
        page 6
game5:  incbin "games\rc705.rom"
        page 7
game6:  incbin "games\rc706.rom"
        page 8
game7:  incbin "games\rc707.rom"
        page 9
game8:  incbin "games\rc710.rom"
        page 10
game9:  incbin "games\rc711.rom"
        page 11
game10:  incbin "games\Rc712.rom"
        page 12
game11:  incbin "games\rc713.rom"
        page 13
game12:  incbin "games\rc714.rom"
        page 14
game13:  incbin "games\rc715.rom"
        page 15
game14:  incbin "games\rc716.rom"
        page 16
game15:  incbin "games\rc717.rom"
        page 17
game16:  incbin "games\rc718.rom"
        page 18
game17:  incbin "games\rc720.rom"
        page 19
game18:  incbin "games\rc721.rom"
        page 20
game19:  incbin "games\rc723.rom"
        page 21
game20:  incbin "games\rc724.rom"
        page 22
game21:  incbin "games\rc725.rom"
        page 23
game22:  incbin "games\rc727.rom"
         page 24
game23:  incbin "games\rc728.rom"
         page 25
game24:  incbin "games\rc729.rom"
         page 26
game25:  incbin "games\rc730.rom"
         page 27
game26:  incbin "games\rc731.rom"
         page 28
game27:  incbin "games\rc732.rom"
         page 29
game28:  incbin "games\mappy2.rom"
         page 30
game29:  incbin "games\rc734.rom"
         page 31
game30:  incbin "games\rc736.rom"
         page 32
game31:  incbin "games\rc737.rom"
         page 33
game32:  incbin "games\rc739.rom"
         page 34
game33:  incbin "games\rc740.rom"
         page 35
game34:  incbin "games\rc746.rom"
         page 36
game35:  incbin "games\KN327.rom"
         page 37
game36:  incbin "games\G001C.rom"
         page 38
game37:  incbin "games\G002C.rom"
         page 39
game38:  incbin "games\G006C.rom"
          page 40
game39:  incbin "games\BCM5.rom"

         code page 0

       org #e000

       INCLUDE	"PT3-RAM.ASM"
       INCLUDE	"AYFX-RAM.ASM"

endpt3ram:
          db 0